jQuery.fn.carousel = function(settings) {

  return this.each(function(){

	settings = jQuery.extend({
		duration: 500,
		showNumber: 3,
		nextBtnLabel: '',
		prevBtnLabel: '',
		btnsAction: function(){
			
		},
		itemDimensions: {
			width: 64,
			height: 64
		}
	}, settings);

    new jQuery.carousel(this, settings);

  });

};

jQuery.carousel = function(e, settings) {

	var element = jQuery(e);
	var clip = jQuery('<div id="carousel-clip"></div>');
	var container = jQuery('<div id="carousel-container"></div>');

	var nextBtn =  jQuery('<div></div>').attr('class', 'carousel-btn carousel-btn-next');
	nextBtn.html(settings.nextBtnLabel);

	var prevBtn =  jQuery('<div></div>').attr('class', 'carousel-btn carousel-btn-prev carousel-btn-prev-disabled');
	prevBtn.html(settings.prevBtnLabel);
	
	var items = element.find('li');

	items.css({
		width: settings.itemDimensions.width,
		height: settings.itemDimensions.height
	});

	var blankSpaces = parseInt( items.css('margin-left') ) + parseInt( items.css('margin-right') + parseInt( items.css('padding-left') ) + parseInt( items.css('padding-right') ) );

	element.css({
		width: ( items.size() + 0 ) * ( settings.itemDimensions.width + blankSpaces )
	});

	var scrollIncrease = Math.ceil( parseInt( element.width() ) / ( items.size() ) ) + settings.itemDimensions.width + 10;

	container.css({
		width: ( settings.showNumber + 0 ) * ( settings.itemDimensions.width + blankSpaces ),
		position: 'relative',
		padding: '0 25px'
	});

	clip.css({
		overflow: 'hidden',
		width: ( settings.showNumber + 0 ) * ( settings.itemDimensions.width + blankSpaces ),
		scrollLeft: 0
	});

	container.append(clip);
	container.append(nextBtn);
	container.append(prevBtn);
	element.wrap(container);

	jQuery('.carousel-btn-next').bind('mousedown', function(){
		jQuery.fn.carousel.scroll( scrollIncrease, settings.duration, this );
		settings.btnsAction();
	});

	jQuery('.carousel-btn-prev').bind('mousedown', function(){
		jQuery.fn.carousel.scroll( -1 * scrollIncrease, settings.duration, this );
		settings.btnsAction();
	});

	clip.scrollLeft(0);

};

jQuery.extend(jQuery.fn.carousel, {

	intervalHandler: 0,

	scroll: function(increase, duration, arrow) {

		var clip = jQuery('#carousel-clip');
		nokia.util.vibra();
		
		if ( increase < 0 ) {
			jQuery(arrow).addClass('carousel-btn-prev-disabled');
		}
		else {
			jQuery(arrow).addClass('carousel-btn-next-disabled');
		}

		clip.animate({scrollLeft: '+=' + increase }, duration, function(){

			if ( increase < 0 && clip.scrollLeft() <= 0 ) {

				jQuery('#carousel-container .carousel-btn-prev').addClass('carousel-btn-prev-disabled');

				return;
			} else if ( increase > 0 && clip.width() - clip.scrollLeft() <= 94 ) {

				jQuery('#carousel-container .carousel-btn-next').addClass('carousel-btn-next-disabled');

				return;
			} else {

				jQuery('#carousel-container .carousel-btn').removeClass('carousel-btn-next-disabled carousel-btn-prev-disabled');

			}

		});
	},

	stop: function() {
		jQuery('#carousel-clip').stop();
	}

});
