(function(){
	
	jQuery.fn.scrollControl = function(settings) {
	
		return this.each(function(){
		
			settings = jQuery.extend({
				jump: 150, //é o quanto o scroll anda
				duration: 1, //duracao da animacao
				standardListener: function(el, arrows) {
					// listener
				}
			}, settings);
		
			new jQuery.scrollControl(this, settings);
		
		});

	};
	
	jQuery.scrollControl = function(el, settings){
		
		jQuery.extend(this, {
			
			init: function(element, settings) {
				var instance = this;
				var el = jQuery(element);
				var isBody = instance.isBody = el.get(0) === jQuery('body').get(0);
				var arrows = instance.arrows = instance.createArrows(el);
				var arrowUp = arrows.up;
				var arrowDown = arrows.down;
				
				instance.positionArrows(el);
				instance.scrollListener(el);
				
				instance.scrollHeight = isBody ? jQuery(document).height() : element.get(0).scrollHeight;
				instance.lastScrollTop = (instance.isBody ? jQuery(window) : element).scrollTop();				
				setInterval(function(){
					
					instance.scrollListener(el);
					instance.positionArrows(el);
					
					instance.scrollHeight = isBody ? jQuery(document).height() : element.get(0).scrollHeight;
					instance.lastScrollTop = (instance.isBody ? jQuery(window) : element).scrollTop();
					
				}, 1000);
				
				jQuery(window).bind('resize', function(){
					
					instance.positionArrows(el);
					instance.scrollListener(el);
					
				});
				
				(isBody ? jQuery(window) : el).bind('scroll', function(){

					instance.scrollListener(el);
										
				});
				
				arrowUp.bind('click', function(){
	
					instance.scroll(el, settings.jump * -1, settings.duration);
					
				});
				
				arrowDown.bind('click', function(){
					
					instance.scroll(el, settings.jump, settings.duration);
					
				});
				
			},
			
			scrollListener: function(element) {
				var instance = this;
				var height = window.innerHeight;
				var lastScrollHeight = instance.scrollHeight;
				var scrollHeight = instance.isBody ? jQuery(document).height() : element.get(0).scrollHeight;
				var scrollTop = (instance.isBody ? jQuery(window) : element).scrollTop();
				
				// nothing changed
				if (scrollTop == instance.lastScrollTop && scrollHeight == lastScrollHeight)
					return;
				
				instance.showArrows();

				if ( scrollHeight - height == 0 )
					instance.hideArrows();
				else if ( scrollTop == 0 )
					instance.hideArrows(instance.arrows.up);
				else if ( instance.isBody && scrollHeight - scrollTop == height + 15  )
					instance.hideArrows(instance.arrows.down);
				else if ( scrollTop == scrollHeight - height )
					instance.hideArrows(instance.arrows.down);

				var standardListener = settings.standardListener;				
					
				if (standardListener)
					standardListener.apply(instance, [element, instance.arrows]);
					
			},
			
			hideArrows: function(arrow) {
				var instance = this;
				
				if (arrow)
					arrow.hide();
				else {
					instance.arrows.up.hide();
					instance.arrows.down.hide();
				}
				
			},
			
			showArrows: function(arrow) {
				var instance = this;
				
				if (arrow)
					arrow.show();
				else {
					instance.arrows.up.show();
					instance.arrows.down.show();
				}
				
			},
		
			scroll: function(element, increase, duration) {
				var instance = this;
				
				element.animate({ scrollTop: '+=' + increase }, duration, function(){
					
					instance.scrollListener(element);
				
				});
			},
			
			createArrows: function(element) {
				var instance = this;
				var arrowUp = jQuery('<div class="jquery-scrollcontrol-arrow jquery-scrollcontrol-arrow-up">&nbsp;</div>');
				var arrowDown = jQuery('<div class="jquery-scrollcontrol-arrow jquery-scrollcontrol-arrow-down">&nbsp;</div>');
				
				element.append(arrowUp);
				element.append(arrowDown);
	
				return { up: arrowUp, down: arrowDown };
				
			},
			
			positionArrows: function(element) {
				var instance = this;
				var isBody = instance.isBody;
				var arrowUp = instance.arrows.up;
				var arrowDown = instance.arrows.down;
				var height = (isBody ? jQuery(window) : element).height();
				var width = (isBody ? jQuery(window) : element).width();
				var lastScrollHeight = instance.scrollHeight;
				var scrollHeight = instance.isBody ? jQuery(document).height() : element.get(0).scrollHeight;
				var scrollTop = (instance.isBody ? jQuery(window) : element).scrollTop();
				
				if (scrollTop == instance.lastScrollTop && scrollHeight == lastScrollHeight)
					return;
				
				arrowUp.css({
					position: isBody ? 'fixed' : 'absolute',
					left: element.offset().left + width - 75,
					top: element.offset().top + 20
				});
		
				arrowDown.css({
					position: isBody ? 'fixed' : 'absolute',
					left: element.offset().left + width - 75,
					top: element.offset().top + window.innerHeight - 65
				});
				/*
				arrowDown.css({
					position: 'fixed',
					left: element.offset().left + width - 75,
					bottom: 0
				});
				*/
				
			}
		
		});
	
		this.init(el, settings);
	
	};
	
})(jQuery);