if (!window.widget) {
	var widget = {

		openURL: function(url) {
			window.open(url);
		},

		preferenceForKey: function(key) {
			return '';
		},

		setPreferenceForKey: function(value, key) {
			return '';
		}

	};
}

if (!window.MenuItem) {

	function MenuItem(label, id) {

		this.label = label;

		this.id = id;

		this.onSelect = function() {};

		this.append = function() {};
		
		this.remove = function() {};
		
	}

}

if (!window.menu) {

	var menu = {
		remove: function(a) {},
		append: function(a) {}
	};

}

var nokia = function(){
    /* nokia */
};

nokia.namespace = function(namespace){
    var levels = namespace.split(".");
    var curLevel = nokia;
    for (var i = (levels[0] == "nokia") ? 1 : 0; i < levels.length; i++) {
        curLevel[levels[i]] = curLevel[levels[i]] ||
        {};
        curLevel = curLevel[levels[i]];
    };
    return curLevel;
};

nokia.namespace('nokia.plugin');
nokia.namespace('nokia.util');
nokia.namespace('nokia.ajax');

jQuery.extend(nokia.util, {
	
	wbr: function(str, r) {
		
		if (!str)
			return '';
		
	    r = r || 15;
	    var t = str.length, out = "";
	   
	    for (var i = 0; i < Math.ceil(t/r); i++)
	        out = [ out, [str.slice(i*r, i*r+r), i*r+r >= t ? "" : "<wbr/>"].join("") ].join("");
	   
	    return out;
	},
	
	loadScript: function(source, cb, old, newId) {
		
		if (old)
			jQuery(old).remove();
	
		var head = document.getElementsByTagName('head')[0];
		
		var script = document.createElement('script');
		script.type = 'text/javascript';
		
		if (newId)
			script.id = newId;
		
		script.onreadystatechange = function () {
			if (this.readyState == 'complete') {
			
				if (cb)
					cb.apply(this, []);	
					
			}

		};
		
		script.onload = function() {
			
			if (cb)
				cb.apply(this, []);
			
		};
		
		script.src= source;
		
		//jQuery(head).prepend( jQuery(script) )
		
		head.appendChild(script);
	
	},
	
	loadCss: function(id, src) {
		
		var style = document.getElementById(id);
		style.href = src;
		
	},
	
	addCommas: function(nStr) {
		nStr += '';
		x = nStr.split('.');
		x1 = x[0];
		x2 = x.length > 1 ? '.' + x[1] : '';
		var rgx = /(\d+)(\d{3})/;
		while (rgx.test(x1)) {
			x1 = x1.replace(rgx, '$1' + ',' + '$2');
		}
		return x1 + x2;
	},

    showLoading: function(selector, hideText){
        var html = '<img src="plugin/img/ajax-loader.gif" />';

        if (!hideText) {
            html += '<p>' + localizedtemplatesContainer[7] + '</p>';
        }

        jQuery(selector || '#loading').addClass('nokia-loading').fadeIn('slow').html(html);
    },

    hideLoading: function(selector){
        jQuery(selector || '#loading').hide();
    },

    setAsVoidHref: function(selector){
        jQuery(selector).attr('href', 'javascript:void(0);');
    },

    maximize: function(selector){
        var windowWidth = jQuery(window).width();
        var windowHeight = jQuery(window).height();
        return jQuery(selector).width(windowWidth).height(windowHeight);
    },

    html_unentity: function(html){
        var element = jQuery('<textarea></textarea>');
        var html = element.html(html).val();
        element = null;
        return html;
    },

    removeCDATA: function(text){
        return jQuery.trim([text].join('').replace('<![CDATA[', '').replace(']]>', ''));
    },

    setRightSoftkeyLabel: function(message, callback){
        if (window.menu && window.menu.setRightSoftkeyLabel) {
            window.menu.setRightSoftkeyLabel(message, callback);
        }
    },

    setLeftSoftkeyLabel: function(message, callback){
        if (window.menu && window.menu.setLeftSoftkeyLabel) {
            window.menu.setLeftSoftkeyLabel(message, callback);
        }
    },

    vibra: function(vibraval, vibratime){
    	
        if (document && document.embeds && document.embeds[0]) {
            var sysinfo = document.embeds[0];
            vibraval = vibraval || 50;
            vibraval = (vibraval >= 100) ? 100 : 50;
            vibratime = vibratime || 25;
            sysinfo.startvibra(100, 100);
        }
    }

});

jQuery.extend(nokia.ajax, {

    JSONProxy: function(url, qtd){
        var proxied = ['http://nwfu.tecnologia.ws/widgets/amazon/proxy.php?q=', (qtd || 10), '&url=', url, '&callback=?'].join('');
        return proxied;
    },

    getRSSFeed: function(url){
        if (!url)
            return false;

        var feed = [];

        var parseFn = function(data){
            $(data).find('item').each(function(){
                var $item = $(this);
                var title = $item.find('title').text();
                var link = $item.find('link').text();
				link = link.replace('amp;','');
                var description = $item.find('description').text();
                var pubDate = $item.find('pubDate').text();

                feed.push({
                    title: title,
                    link: link,
                    description: description,
                    pubDate: pubDate
                });
            });

            if (callback) {
                callback(feed, data);
            }
        };

        $.post(url, {}, parseFn, "xml");
    }

});
