nokia.plugin.amazon = function(){
    this.init();
};

jQuery.extend(nokia.plugin.amazon.prototype, {

    init: function(isChangeLanguage){
        var instance = this;
        var searchInput = jQuery('#mainSearch');

		var helpButton = new MenuItem(localizedHelp['title'], instance.MENU_HELP);
		var aboutButton = new MenuItem(localizedAbout['title'], instance.MENU_ABOUT);
		var homeButton = new MenuItem(localizedLanguage['home'], instance.MENU_HOME);
		var backhome =  new MenuItem(localizedMenu['Back'], instance.MENU_BACK);
		
		instance.backHome = backhome;
		
		var helpView = jQuery('#helpView');
		var aboutView = jQuery('#aboutView');
		var homeView = jQuery('#homeView');
		
		var preferenceCountry = widget.preferenceForKey('country');
		
		if (preferenceCountry && !isChangeLanguage) {
			
			var script = preferenceCountry + '.lproj/localizedUrl.js';
    		var css = preferenceCountry + '.lproj/localizedLayout.css';
    		jQuery('#mainHeader h1').css('backgroundImage', 'none');
            jQuery('#mainHeader h1 a').css('backgroundImage', 'url('+preferenceCountry+'.lproj/amazon-logo-'+preferenceCountry+'.png)');
	    	
	    	nokia.util.loadScript(script, function(){
    		
	    		instance.init(true);
    		
			}, jQuery('#langScript'), 'langScript');
			
			return;
			
		}
		
    	//jQuery('#mainHeader h1').css('backgroundImage', 'url('+currentCountry+'.lproj/amazon-logo-'+currentCountry+'.png)');
		
		jQuery('.view').hide();
		
		jQuery('#homeView, #topsellers').show();
		
		jQuery('#goldbox').hide();
		
		helpView.find("h2").find("#help").html(localizedHelp['text']);
		aboutView.find("h2").find("#version").html(localizedAbout['text'].replace("{version}",this.VERSION));
					
		helpButton.onSelect = function() {
			jQuery('.view').hide();
			helpView.show();
			
			nokia.util.setRightSoftkeyLabel(localizedMenu['Back'], function() {
				instance.goBack(resultListView);
				nokia.util.setRightSoftkeyLabel("",null);
			});
		};
			
		aboutButton.onSelect = function() {
			jQuery('.view').hide();
			aboutView.show();
			
			nokia.util.setRightSoftkeyLabel(localizedMenu['Back'], function(){
				instance.goBack(resultListView);
				nokia.util.setRightSoftkeyLabel("", null);
			});
		};
		
		var backHomeFunction = function(){
		
			jQuery('.view').hide();
			
			jQuery('#topSellers').show();
			
			homeView.show();
				
		};
		
		backhome.onSelect = backHomeFunction;
		
		homeButton.onSelect = function(){
			backHomeFunction();
			nokia.util.setRightSoftkeyLabel("",null);
	        searchInput.val(localizedSearch[3]);			
		}
			
		if (window.menu) {
			menu.append(homeButton);
			//menu.append(backhome);
			menu.append(helpButton);
			menu.append(aboutButton);
		}
            
        instance.BASE_BEST_SELLERS = localizedBaseUrl['index'];
    
    	instance.BASE_AMAZON_URL = localizedBaseUrl['amazon'];
    
		instance.DESCRIPTION_LINK = localizedBaseUrl['amazonUrl'] + "/gp/aw/d.html?a={asin}&at=" + localizedBaseUrl['tag'];
		
	    instance._createLanguageMenu();
        
        instance._attachEvents();
        
        instance._createCarousel();
        
        instance._replaceLangageValues();
        
        searchInput.removeClass('empty');
        searchInput.addClass('empty');
        
		searchInput.unbind('keyup');

		var cleanup = function(){
        	if ( !searchInput.val() )
        		searchInput.addClass('empty');
        	else
        		searchInput.removeClass('empty');
        };

        searchInput.change(cleanup);
		searchInput.keyup(cleanup);
        
        if ( !jQuery('.jquery-scrollcontrol-arrow').size() ) {
        
	        jQuery('body').scrollControl({
	            jump: 450,
	            duration: 200,
	            standardListener: function(el, arrows) {
	            	
	            	if ( jQuery(window).height() < 150 ) {
	            		arrows.up.hide();
						arrows.down.hide();
					}
	            	
	            }
	        });
        
    	}
        
        setTimeout(function(){
          
            selectModeView();
            
            var globalLoading = $('#globalLoading');
        
        	globalLoading.hide();
        	
        	jQuery('#topSellers').show();
            
        	/*
            clearInterval(instance.miniviewInterval);
            instance.miniviewInterval = setInterval(function(){
            	
	            instance.searchGoldenBoxMiniView();
            	
            }, 900000);
            */
            
        }, 1000);
        
    },
    
    _attachEvents: function(){
        var instance = this;
        var resultListView = jQuery('#resultListView');
        var searchInput = jQuery('#mainSearch');
        var hideProductDetails = jQuery('.hideProductDetails');
        var goButton = jQuery('#goBtn');
        var goldboxMoreDeals = jQuery('#goldboxMoreDeals');
        var hideGoldBoxList = jQuery('.hideGoldBoxList');
        var hideBestSellerList = jQuery('.hideBestSellerList');
        var backToMainPage = jQuery('#backToMainPage');
        
        jQuery('#mainHeader h1 a').unbind('click');
        jQuery('#mainHeader h1 a').click(function(){
        	
        	nokia.util.vibra();
        	
			instance.activateElement(jQuery('#mainHeader h1 a'));
			
        	widget.openURL( localizedBaseUrl['mobileUrl'] + "&linkCode=plm&tag=" + localizedBaseUrl['tag'] );
        				
			
        });
        
        searchInput.val(localizedSearch[3]);
        
        //searchInput.unbind('focus');

        searchInput.focus(function(){
        	if ( searchInput.hasClass('empty') )
        		searchInput.val('');
        	
        	searchInput.removeClass('unfocused');
        });
      
        //searchInput.unbind('blur');

        searchInput.blur(function(){
        	if ( searchInput.hasClass('empty') )
        		searchInput.val(localizedSearch[3]);
        	
        	searchInput.addClass('unfocused');
        });
        
        goButton.unbind('blur');
        goButton.blur(function(){
        	goButton.removeClass('goBtnActive');
        });
        
        goButton.unbind('click');
        goButton.click(function(){
            var keywords = jQuery.trim(searchInput.val());
            
            goButton.addClass('goBtnActive');
			
			if(keywords != null && keywords != "" && keywords != localizedSearch[3]) {
				searchInput.removeClass('empty');	
				nokia.util.vibra();
            	instance.searchBlended(keywords);
			}
            else {
            	nokia.util.vibra();
				jQuery('#mainHeader-error').show();
            	setTimeout(function(){
            		jQuery('#mainHeader-error').hide();
            	}, 2000);
            	return;
            }
        });
        
        goldboxMoreDeals.unbind('click');
        goldboxMoreDeals.click(function(){
        	
        	nokia.util.vibra();
        	
            instance.searchGoldenBoxList();
            
            return false;
        });
        
        searchInput.unbind('keypress');
        searchInput.keypress(function(event){
            var keyCode = event.keyCode;
            if (keyCode == 13) {
                var keywords = searchInput.val();
                instance.searchBlended(keywords);
                return false;
            }
        });
        
        backToMainPage.unbind('click');
        backToMainPage.click(function(){
            resultListView.hide();
            instance.showLayoutBoxes();
            
            return false;
        });
    },
    
    _createCarousel: function(){
        var instance = this;
        var carousel = jQuery('#carousel');
        var limit = 6;
        
    	carousel.css({
    		height: '295px'
    	});

    	limit = 9;

        carousel[0].innerHTML = '';
        
        jQuery.each(bestSellersCategories, function(i, o){
        	
        	if ( i < limit ) {
        	
	            var category = o.key;
	            var title = o.name;
	            var img = o.img;
	            var carouselItem = '<li class="carouselItem" onclick="nokia.util.vibra();amazon.searchBestSellers(\''+category+'\', \''+title+'\');"><a href="#"><img src="' + img + '" /></a></li>';
	            
	            carousel[0].innerHTML += carouselItem;
	            
        	}

	    });
        
    },
    
    _changeLanguageScript: function(country) {
    	var instance = this;
    	var script = country + '.lproj/localizedUrl.js';
    	var css = country + '.lproj/localizedLayout.css';
		
		if(country == "am") {
			if(!window.loadedDefault) {
				//there's an actual country, so it's not "am". since all other countries are .com
				var actualCountry = document.embeds[0].language;
				
				if (actualCountry != "de" && actualCountry != "fr" && 
					actualCountry != "ca" && actualCountry != "en") {
						
					window.widget.setPreferenceForKey(null, 'country');
					script = actualCountry + '.lproj/localizedUrl.js';
					css = actualCountry + '.lproj/localizedLayout.css';
				}
			}
			else {
				//no actual country, just loading from root
				script = 'localizedUrl.js';
				css = 'localizedLayout.css';				
			}
		}
    	
    	nokia.util.loadScript(script, function(){
    		
    		instance.init();
    		jQuery('#mainHeader h1').css('backgroundImage', 'none');
    		jQuery('#mainHeader h1 a').css('backgroundImage', 'url('+country+'.lproj/amazon-logo-'+country+'.png)');
    	
    	}, jQuery('#langScript'), 'langScript');
    	
    },
    
    _createLanguageMenu: function() {
    	var instance = this;
    	
    	var amButton = new MenuItem('Amazon.com', instance.MENU_AM);
		var ceButton = new MenuItem('Amazon.ca', instance.MENU_CE);
		var enButton = new MenuItem('Amazon.co.uk', instance.MENU_EN);
		var frButton = new MenuItem('Amazon.fr', instance.MENU_FR);
		var geButton = new MenuItem('Amazon.de', instance.MENU_GE);
		
		var selectButton = new MenuItem(localizedLanguage['selectsite'], 10);
		window.menu.append(selectButton);
		
		selectButton.remove(amButton);
		selectButton.remove(ceButton);
		selectButton.remove(enButton);
		selectButton.remove(frButton);
		selectButton.remove(geButton);
		
		amButton.onSelect = function() {
			
			widget.setPreferenceForKey('am', 'country');
			
			instance._changeLanguageScript('am');
			
		};
			
		ceButton.onSelect = function() {
			
			widget.setPreferenceForKey('en-CA', 'country');
			
			instance._changeLanguageScript('en-CA');
			
		};
		
		enButton.onSelect = function() {
			
			widget.setPreferenceForKey('en', 'country');
			
			instance._changeLanguageScript('en');
			
		};
		
		frButton.onSelect = function() {
			
			widget.setPreferenceForKey('fr', 'country');
			
			instance._changeLanguageScript('fr');
			
		};
		
		geButton.onSelect = function() {
			
			widget.setPreferenceForKey('de', 'country');
			
			instance._changeLanguageScript('de');
			
		};
    	
		selectButton.append(amButton);
		selectButton.append(ceButton);
		selectButton.append(enButton);
		selectButton.append(frButton);
		selectButton.append(geButton);
		
    },
    
    _replaceLangageValues: function() {
    	var instance = this;
    	
    	jQuery('.lang').each(function(i, o){
    		
    		o.innerHTML = localizedLanguage[ jQuery(o).attr('langval') ];
    		
    	});
    	    	
    },
    
    getProductsFromSearch: function() {
    	var instance = this;
    	
    		
    },
    
    getProductDetails: function(asin){
        var instance = this;
        var productRow = jQuery('#' + asin);
        var productTemplate = jQuery( '<span>' + jQuery('#productsDetailsTemplate').html() + '</span>');
        var productDetails = productRow.find('.productDetails');
        
        productDetails.show().html(productTemplate.html());
        
        var loading = productDetails.find('.loadingDetails');
        nokia.util.vibra();
        nokia.util.showLoading(loading);
        
        var data = {
            itemId: asin
        };
        
        instance.search('', 'product', data, function(data){
            var product = data.Item;
            var description = product.desc;
            var title = product.title;
            var lowestnewprice = product.lowestnewprice || localizedProductDetails[0];
            var lowestusedprice = product.lowestusedprice;
            var price = product.price || localizedProductDetails[0];
            var thumburl = product.thumburl;
            var thumbdims = product.thumbdims;
            var url = instance.DESCRIPTION_LINK.replace('{asin}', asin);
            
            productDetails.find('.productOurPrice').html(lowestnewprice);
            productDetails.find('.productListPrice').html(lowestusedprice);
            productDetails.find('.productImage').attr('src', thumburl);
            
            productDetails.find('.viewFullDescription').attr('href', 'javascript:void(0);').click(function(){
            	
            	nokia.util.vibra();
            	
            	widget.openURL(url);
                
                return false;
            });
            
            productDetails.find('.productImage').click(function(){
            	
            	nokia.util.vibra();
            	
                widget.openURL(url);
                
                return false;
            });
            
            if (!lowestusedprice) {
                productDetails.find('.productListPriceWrapper').hide();
            }
            
            productDetails.find('.productInfo').removeClass('nokia-hidden');
            nokia.util.hideLoading(loading);
        });
        
    },
    
    searchGoldenBox: function(){
        var instance = this;
        var goldboxContainer = jQuery('#goldbox');
        var goldboxContent = jQuery('#goldboxContent');
        var loading = goldboxContent.find('.loadingGoldBox');
        var globalLoading = $('#globalLoading');
        
        globalLoading.hide();
        
        if ( !currentCountry || currentCountry != "am" ) {
        	
        	goldboxContainer.hide();
            selectModeView();
        	
            return;
        } else {
        	
        	goldboxContainer.show();
            selectModeView();
        	
        }
        
        nokia.util.showLoading(loading, true);
        goldboxContent.find('.itemData').hide();
        
        instance.getGoldenBoxArrayItems(function(feed){
            var itemRank = feed[0];
            
            if (itemRank) {
                var description = nokia.util.html_unentity(itemRank.description);
                var link = itemRank.link;
                var pubDate = itemRank.pubDate;
                var title = itemRank.title;
                var titleEl = goldboxContainer.find('.itemTitle');
                
                titleEl.attr('href', 'javascript:void(0);').html(title).click(function(event){
                	
                	// Link estático enviado pelo Daniel
                	link = 'http://www.amazon.com/gp/aw/gb.html/ref=me_amb_463135901/183-3024930-4594663/?aid=aw_gw&apid=463135901&arc=1&asn=center-15&arid=1FK6EQ2322WZW0D51YB3&at=' + localizedBaseUrl['tag'];
                	
                	nokia.util.vibra();
                	
                    widget.openURL(link);
                    
                    return false;
                });
                
                goldboxContainer.find('.description').html(description);
                goldboxContent.find('.itemData').show();
                nokia.util.hideLoading(loading);
            }
                        
            globalLoading.hide();
            selectModeView();
            
        });
    },
    
    searchGoldenBoxMiniView: function(tries){
        var instance = this;
        var miniviewContainer = jQuery('#miniview');
        var miniviewContent = jQuery('#miniViewContent');
        var loading = miniviewContent.find('.miniViewLoading');
        var miniviewOffers = miniviewContainer.find('.miniview-offers');
                
		var randomIndex = Math.ceil( Math.random() * bestSellersCategories.length - 1 );
		var randomCategory = bestSellersCategories[randomIndex];
		
		var baseUrl = localizedBaseUrl[randomCategory.key];
		var urlRss = instance.BASE_BEST_SELLERS + baseUrl;
		var url = nokia.ajax.JSONProxy(urlRss, 10);
		
		clearInterval(instance.bestSellersShowInterval);
		
		miniviewOffers.html( localizedtemplatesContainer[7] );
		nokia.util.showLoading(loading, true);
		
		tries = tries || 1;
		
		instance.getRSSFeed(urlRss, function(feed) {
		//jQuery.getJSON(url, function(feed){
			
			// tries prevents infinite loops
			if (tries > 5)
				return;
			
			if (!feed.length) {
				instance.searchGoldenBoxMiniView(tries + 1);
			
				return;	
			}
			
			miniviewContent.find('.miniview-offers').show();
            nokia.util.hideLoading(loading);
	
			miniviewOffers.attr('href', 'javascript:void(0);');
			
			var currentFeed = feed[0];
			var content = currentFeed.title;		
			var contentTitle = '<a href="javascript:void(0);">' + content.substring(content.indexOf(':') + 1, content.length) + '</a>';
			var categoryEl = '<a href="javascript:void(0);">' + randomCategory.name + ':' + '</a>';
			
			/*
			categoryEl.click(function(){
				
				instance.searchBestSellers(randomCategory.key, randomCategory.name);
				
				return false;
			});
			*/
			
			/*
			contentTitle.unbind('click');
			contentTitle.click(function(){
				var link = currentFeed.link.replace(/amp\;/ig,'');
				
				widget.openURL( link );
				
				return false;
			});
			*/
		
			miniviewOffers[0].innerHTML = '';
			miniviewOffers[0].innerHTML += categoryEl;	
			miniviewOffers[0].innerHTML += contentTitle;	
			
			instance.bestSellersShowIndex = false;
			
			clearInterval(instance.bestSellersShowInterval);
		
			instance.bestSellersShowInterval = setInterval(function(){
				
				instance.bestSellersShowIndex = instance.bestSellersShowIndex === false || instance.bestSellersShowIndex >= feed.length - 1 ? 1 : instance.bestSellersShowIndex+1;
				
				currentFeed = feed[instance.bestSellersShowIndex];
				
				if (currentFeed) {
					
					content = currentFeed.title;		
					contentTitle = '<a href="javascript:void(0);">' + content.substring(content.indexOf(':') + 1, content.length) + '</a>';
					
					miniviewOffers[0].innerHTML = '';
					miniviewOffers[0].innerHTML += categoryEl;	
					miniviewOffers[0].innerHTML += contentTitle;
					
					/*
					contentTitle.unbind('click');
					contentTitle.click(function(){
						var link = currentFeed.link.replace(/amp\;/ig,'');
				
						widget.openURL( link );
						
						return false;
					});
					*/
				
					miniviewContent.find('.miniview-offers').fadeOut(1000, function(){
										
						miniviewContent.find('.miniview-offers').show();
					
					});
				
				}
			
			}, 15000);	
			
		});
		    	
        return;

        /*
        nokia.util.showLoading(loading, true);
        miniviewContent.find('.goldboxLogo').hide();
        miniviewContent.find('.miniview-offers').hide();
        
        instance.getGoldenBoxArrayItems(function(feed){
            var itemRank = feed[0];
            
            if (itemRank) {
                var description = nokia.util.html_unentity(itemRank.description);
                var link = itemRank.link;
                var title = itemRank.title;
                
                miniviewContainer.find('.miniview-offers').attr('href', link).html(title);
                miniviewContent.find('.miniview-offers').fadeIn();
                nokia.util.hideLoading(loading);
            }
        });
        */
    },
    
    searchGoldenBoxList: function(){
        var instance = this;
        var goldboxContainer = jQuery('#listGoldItensContainer');
        var goldenBoxItensContainer = goldboxContainer.find('.goldenBoxItensContainer');
        
        goldboxContainer.show();
        nokia.util.maximize(goldboxContainer);
        
        goldenBoxItensContainer.hide();
        instance.toggleLayoutBoxes();
        
        nokia.util.vibra();
        nokia.util.showLoading('#loadingDetailsGoldBox');
        
        instance.getGoldenBoxArrayItems(function(feed){
        
            jQuery.each(feed, function(){
                var itemRank = this;
                
                if (itemRank) {
                    var description = nokia.util.html_unentity(itemRank.description);
                    var link = itemRank.link;
                    var pubDate = itemRank.pubDate;
                    var title = itemRank.title;
                    var template = jQuery('#goldBoxEntryTemplate').clone();
                    var entryContainer = jQuery('<div class="goldBoxEntry"></div>');
                    
                    template.find('.itemTitle').attr('href', link).html(title);
                    template.find('.description').html(description);
                    
                    entryContainer.append(template);
                    goldenBoxItensContainer.append(entryContainer);
                }
            })
            
            hideAllViews();
            goldenBoxItensContainer.show();
            nokia.util.hideLoading('#loadingDetailsGoldBox');
            
            goldenBoxItensContainer.find('a[href^=http]').each(function(){
                $(this).click(function(){
                    var href = $(this).attr('href');
                    
                    $(this).attr('href', 'javascript:void(0);')
                    
                    // Link estático enviado pelo Daniel
                    href =  'http://www.amazon.com/gp/aw/gb.html/183-3024930-4594663?v=bd&at=' + localizedBaseUrl['tag'];
                    
                    nokia.util.vibra();
                
                    widget.openURL(href);
                    
                    return false;
                });
                
            });
            
            goldenBoxItensContainer.find('.buyBtn').click(function(){
            	
            	var href = 'http://www.amazon.com/gp/aw/gb.html/183-3024930-4594663?v=bd&at=' + localizedBaseUrl['tag'];
                
            	nokia.util.vibra();
            	
            	widget.openURL(href);
                    
                return false;
            	
            });
            
			nokia.util.setRightSoftkeyLabel("back",null);
            
        });
    },
    
    getGoldenBoxArrayItems: function(callback){
        var instance = this;
        var urlGoldBox = 'http://rssfeeds.s3.amazonaws.com/goldbox?at=' + localizedBaseUrl['tag'];
        var url = nokia.ajax.JSONProxy(urlGoldBox, 5);
        
        jQuery.getJSON(url, function(feed, data){
            if (callback) {
                callback.apply(instance, [feed, data]);
            }
        });
        
    },
    
    getProductsPaginators: function(keywords, category, total, pagenum){
        var instance = this;
        var isLast = pagenum >= Math.ceil(total / this.PAGE_SIZE);
        var isFirst = pagenum < 2;

        var paginator = '<div id="paginator" '+( isFirst && isLast ? 'style="display:none;"' : 'style="display:block;"' )+
						' class="navigation nokia-hidden">' + 
						
						'<a href="#" '+( isFirst ? 'style="display:none;"' : '' )+
						' class="goFirst" onclick="amazon.searchProducts(\''+keywords+'\', \''+category+'\', \''+
						(1)+'\');"></a>' +
						
						' <a href="#" '+( isFirst ? 'style="display:none;"' : '' )+
						' class="goBack" onclick="amazon.searchProducts(\''+keywords+'\', \''+category+'\', \''+
						(pagenum - 1)+'\');">'+localizedpaginator[0]+'</a>' + 
						
						' <a '+ ( isLast ? 'style="display:none;"' : '' )+
						' href="#" class="goLast" onclick="amazon.searchProducts(\''+keywords+'\', \''+category+'\', \''+(Math.ceil(total/this.PAGE_SIZE))+'\');"></a>' +

						' <a '+
						( isLast ? 'style="display:none;"' : '' )+
						' href="#" class="goNext" onclick="amazon.searchProducts(\''+keywords+'\', \''+category+'\', \''+(pagenum + 1)+'\');">'+
						localizedpaginator[1]+'</a>' + '</div>';
						
        return paginator;
    },
    
    toggleLayoutBoxes: function(){
        var goldbox = jQuery('#goldbox');
        var topSellers = jQuery('#topSellers');
        
        goldbox.toggle();
        topSellers.toggle();
    },
    
    showLayoutBoxes: function(){
        var goldbox = jQuery('#goldbox');
        var topSellers = jQuery('#topSellers');
        
        goldbox.show();
        topSellers.show();
    },
    
    hideLayoutBoxes: function(){
        var goldbox = jQuery('#goldbox');
        var topSellers = jQuery('#topSellers');
        
        goldbox.hide();
        topSellers.hide();
    },
    
    search: function(keywords, type, data, callback){
        var instance = this;
        type = type || 'blended';
        
        var url = instance.getUrlSearchFromType(type, keywords, data);
        
        //jQuery.getJSON(url, function(data){
		instance.getSearchItems(url, function(data) {
            if (callback) {
                callback.apply(instance, [data]);
            }
        });
    },
    
    searchBlended: function(keywords, callback){	
        var instance = this;
        var resultListView = jQuery('#resultListView');
        var bestSellerListContainer = jQuery('#bestSellerListContainer');
        var listGoldItensContainer = jQuery('#listGoldItensContainer').hide();
        var resultsListContainer = jQuery('#resultsListContainer');
        var itemListOL = resultListView.find('.itemsList ol');		
		var productsContainer = resultsListContainer.find('.resultsItensContainer');		
        var goButton = jQuery('#goBtn');
		var foundResults = false;
		var resultHtml = "";
		var images = [];
        
        if (!keywords) {
            nokia.util.vibra();
            
            jQuery('#mainHeader-error').show();
            
            setTimeout(function(){
            	
            	jQuery('#mainHeader-error').hide('slow');
            	
            }, 2000);
            
            return false;
        }
        
        // Store last keyword
        instance.lastKeyword = keywords;
        
        // Empty category name
        resultsListContainer.find('.category').empty();
		resultsListContainer.find('.resultsnumber').empty();
		
        nokia.util.vibra();
        nokia.util.showLoading();
        resultListView.hide();
        bestSellerListContainer.hide();
        listGoldItensContainer.hide();
        resultsListContainer.hide();
        instance.hideLayoutBoxes();
        
        instance.search(keywords, 'blended', {store: "aps", page: "1"}, function(data){
            goButton.removeClass('goBtnActive');

            if (data && data.searchResults) {
				var html = "";
				var total = data.totalResults;
            	var itemsList = data.searchResults;
				foundResults = true;

		        productsContainer.empty();            
            	productsContainer.addClass('productsList');
            	productsContainer.attr('start',1);
            	productsContainer.attr('id', 'products_' + data.currentCategory);
            	productsContainer.hide();
            	productsContainer.html('');
				
				jQuery.each(itemsList, function(key, value){
                	var item = this;
					var itemsListTemplate = instance.buildItemsListTemplate(instance, item);
					images.push({asin:item.asin, image:item.imageSmall});
					productsContainer[0].innerHTML += itemsListTemplate;
            	});
								
                var categories = data.categories;
				
				jQuery.each(categories, function(index, value) {
					var result = this;
					var count = result.count;
					var label = decodeURIComponent(escape(result.label));
					var alias = result.alias;
					var categoryId = "category_" + alias;
					
					results = nokia.util.addCommas(count);
                   	var message = [label, ' (', count, ')'].join('');
                    var categoryContainer = '<li id="'+categoryId+'" data-category="'+label+'" data-index="'+index+'" class="category nokia-db"><a onclick="nokia.util.vibra();amazon.searchProducts(\''+keywords+'\', \''+alias+'\', 1);" href="javascript:void(0);" class="categoryTitle">'+message+'</a></li>';
                    html += categoryContainer;
				});

				resultHtml = html;
		    }
            else {
				if(data.requestStatus == 0) {
					//disconnected
					html = localizedLanguage['categoryunavailble'];
				}
				else if(data.requestStatus == 200) {
					if(data.jqueryStatus == "parsererror") {
						//content is HTML, no matches
						html = localizedLanguage['noresults'];
					}
					else {
						html = "Unexpected error:" + data.requestStatus + "-" + data.jqueryStatus + "-" + data.jqueryError;
					}
				}
				else {
					html = "Error:" + data.requestStatus + "-" + data.jqueryStatus + "-" + data.jqueryError;
				}
				
				resultHtml = html;
			}
			
			//no matter what has happened, display HTML and hide the views
            if (callback) {
                callback.apply(instance, [data]);
            }
						
			hideAllViews();
			itemListOL[0].innerHTML = '<div>' + html + '</div>';	
			
			if(foundResults) {
				resultListView.find("h2").remove();
				
				productsContainer.show();
				resultsListContainer.show();
				resultListView.before(resultsListContainer);
				resultListView.css('margin-top', '0');				
				
			}
						
			resultListView.show();
			nokia.util.hideLoading();
			
			var backFunction = function(){	
				instance.goBack(resultListView);
				nokia.util.setRightSoftkeyLabel("",null);
			}
                
			instance.backHome.onSelect = backFunction;
			
			nokia.util.setRightSoftkeyLabel(localizedMenu['Back'], backFunction);
			
			setTimeout(function() {
				for (var i = 0; i < images.length; i++) {
					var image = images[i];
					instance.getImage(image.asin, image.image);
				}
			}, 500);
        });

    },
    
    searchProducts: function(keywords, category, page, callback){
        var instance = this;
        var categoryId = '#category_' + category;
        var categoryItem = jQuery(categoryId);
        var resultListView = jQuery('#resultsListContainer');
		var productsContainer = resultListView.find('.resultsItensContainer');		
		var page = (typeof(page) == "undefined") ? 1 : page;
		var images = [];
        
        nokia.util.vibra();
        instance.hideLayoutBoxes();
        
        var data = {
            store: category,
            page: page
        };
        
        categoryItem.find('.categoryTitle').after('<span>' + localizedtemplatesContainer[6] + '</span>');
        
        hideAllViews();
		nokia.util.showLoading();
        
        instance.search(keywords, 'singleCategory', data, function(data){
			
			try {
				if (data && data.searchResults) {
					var total = data.totalResults;
					var page = Math.ceil(parseInt(data.searchResults[0].resultNumber) / this.PAGE_SIZE);
					var itemsList = data.searchResults;
					var paginators = instance.getProductsPaginators(keywords, category, total, page);
					var start = page * this.PAGE_SIZE - 9;
					
					productsContainer.addClass('productsList');
					productsContainer.attr('start', start);
					productsContainer.attr('id', 'products_' + category);
					productsContainer.hide();
					
					productsContainer.html('');
					
					jQuery.each(itemsList, function(key, value){
						var item = this;
						var itemsListTemplate = instance.buildItemsListTemplate(instance, item);
						images.push({
							asin: item.asin,
							image: item.imageSmall
						});
						productsContainer[0].innerHTML += itemsListTemplate;
					});
					
					productsContainer[0].innerHTML += paginators;
					
					nokia.util.hideLoading();
					
					productsContainer.show();
					resultListView.show();
					categoryItem.children('span:first').remove();
					
					if (callback) {
						callback.apply(instance, [data]);
					}
					
					var isLast = (page >= Math.ceil(total / 10));
					var end = !isLast ? start + 9 : total;
					
					resultListView.find('.resultsnumber').get(0).innerHTML = nokia.util.addCommas(start) + "-" +
					nokia.util.addCommas(end) +
					" of " +
					nokia.util.addCommas(total);
					
					resultListView.find('.category').get(0).innerHTML = " - " + decodeURIComponent(escape(data.currentCategory));
					
					setTimeout(function() {
						for (var i = 0; i < images.length; i++) {
							var image = images[i];
							instance.getImage(image.asin, image.image);
						}
					}, 500);
				}
				else {
					var html = "";
					
					if (data.requestStatus == 0) {
						//disconnected
						html = localizedLanguage['categoryunavailble'];
					}
					else 
						if (data.requestStatus == 200) {
							if (data.jqueryStatus == "parsererror") {
								//content is HTML, no matches
								html = localizedLanguage['noresults'];
							}
							else {
								html = "Unexpected error:" + data.requestStatus + "-" + data.jqueryStatus + "-" + data.jqueryError;
							}
						}
						else {
							html = "Error:" + data.requestStatus + "-" + data.jqueryStatus + "-" + data.jqueryError;
						}
					
					productsContainer[0].innerHTML = "<div>" + html + "</div>";
					productsContainer.show();
					resultListView.show();
					categoryItem.children('span:first').remove();
					
					nokia.util.hideLoading();
				}
			}
			catch(e) {
				//really unexpected
				alert("Unexepected error:" + e);
			}
			
			var backFunction = function(){
				
				// Gets last keyword and call searchBlended
				var lastKeyword = instance.lastKeyword;
					
				if (lastKeyword) {
					instance.searchBlended(lastKeyword);
				}
				else {
					instance.goBack(resultListView);
					resultListView.show();
				}
			};

			instance.backHome.onSelect = backFunction;
			nokia.util.setRightSoftkeyLabel(localizedMenu['Back'], backFunction);
        });
        
    },
    
    searchBestSellers: function(category, title){
        var instance = this;
		var baseUrl = localizedBaseUrl[category];
        var urlRss = instance.BASE_BEST_SELLERS + baseUrl+'&num=10';
        var url = nokia.ajax.JSONProxy(urlRss, 10);
    	var bestSellerListContainer = jQuery('#bestSellerListContainer');
		var bestSellerItensContainer = bestSellerListContainer.find('.bestSellerItensContainer').html('');
        var reloadFeed = false;
		
        title = title;
        
        hideAllViews();
        
        category = [category].join('');
        instance.hideLayoutBoxes();
        bestSellerListContainer.show();
        //bestSellerItensContainer.show();
        nokia.util.maximize(bestSellerListContainer);
        //bestSellerItensContainer.hide();
        nokia.util.showLoading('#loadingDetailsBestSeller');
        bestSellerListContainer.find('.category').html(title);
		
		if(!instance.feedCache[urlRss]) {
			reloadFeed = true;
		}
		else {
			var feed = instance.feedCache[urlRss];
			var feedDate = feed.date.getTime();
			var now = new Date().getTime();
			var oneHour = 1000 * 60 * 60; // one hour
			
			if(now - feedDate >= oneHour) {
				reloadFeed = true;
			}
		}
		
		if (reloadFeed) {
			//jQuery.getJSON(url, function(feed){
			instance.getRSSFeed(urlRss, function(feed){
				if (!feed || feed.length == 0) {
				
					var noCategoryText = jQuery('<li></li>');
					noCategoryText.css('textAlign', 'center');
					noCategoryText.html(localizedLanguage['categoryunavailble']);
					
					bestSellerItensContainer.append(noCategoryText);
					
					nokia.util.hideLoading('#loadingDetailsBestSeller');
					bestSellerItensContainer.show();
					
					return;
					
				}
				var index = 1;
				//regexes
				var ratingPattern = new RegExp(localizedMapping['rating'], 'gi');
				var ourPricePattern = new RegExp(localizedMapping['ourprice'], 'gi');
				var listPricePattern = new RegExp(localizedMapping['listprice'], 'gi');
				
				//alert(new Date());
				jQuery.each(feed, function(){
					var result = this;
					var title = result.title.replace(/#(\d+):/, (index++) + ".");
					var description = nokia.util.removeCDATA(result.description);
					var link = jQuery.trim(result.link);
					var templateHTML = jQuery('#bestSellerEntryTemplate').get(0).innerHTML;
					var template = jQuery('<span>' + templateHTML + '</span>');
					var titleEl = template.find('.itemTitle').html(title);
					
					var descArray = description.split('<br />');
					var rating = '';
					var ourprice = '';
					
					var u = jQuery.each(descArray, function(i, l){
					
						var pattern = ratingPattern; //new RegExp(localizedMapping['rating'], 'gi');
						descArray[i] = jQuery.trim(l);
						
						if (descArray[i].length == 0) 
							return;
						
						if (pattern.test(l)) {
						
							rating = descArray[i];
							
							descArray[i] = '';
							
						}
						
						pattern = ourPricePattern; //new RegExp(localizedMapping['ourprice'], 'gi');
						if (pattern.test(l)) {
						
							l = l.replace(localizedMapping['ourprice'], localizedLanguage['ourprice']);
							var parts = l.split(":");
							
							descArray[i] = '<span class="itemOurPrice">' + parts[0] + ':</span><span class="red">' + parts[1] + '</span>';
							
						}
						pattern = listPricePattern; //new RegExp(localizedMapping['listprice'], 'gi');
						if (pattern.test(l)) {
						
							descArray[i] = '<span class="itemOurPrice">' + l + '</span>';
							
						}
					});
					
					description = descArray.join('<br />');
					//description = description.replace("_SL75_","_SL160_").replace();
					
					var ratingImgs = '';
					
					if (rating) {
					
						var ratigNumbers = jQuery.trim(rating.substr(rating.indexOf(':') + 1)).split('/');
						var starsNumber = parseFloat(jQuery.trim(ratigNumbers[0]));
						var maxStars = parseFloat(jQuery.trim(ratigNumbers[1]));
						
						ratingImgs = instance.buildRatingStars(starsNumber, maxStars).html();
						
					}
					
					var part1 = description.substring(0, description.indexOf("<a"));
					var part2 = description.substring(description.indexOf("/a>") + 3);
					
					description = part1 + part2;
					description = description.replace(/(<br \/>)+/i, '');
					description = description.replace(/(<br \/>)+/ig, '<br />');
					
					var test = jQuery("<span>" + description + "</span>");
					var allLinks = [];
					
					test.find("a").each(function(){
						allLinks.push($(this).text());
					});
					
					description = description.replace(/<a.*\/a>/, allLinks.join(", "));
					
					link = link.replace(/amp\;/ig, '');
					link += "&tag=" + localizedBaseUrl['tag'] + "&linkCode=plm";
					
					var openLinkFunction = "javascript:nokia.util.vibra();widget.openURL('" + link + "'); return false";
					
					titleEl.attr('href',openLinkFunction);
					
					template.find('.stars-wrapper').get(0).innerHTML = ratingImgs;
					
					template.find('.description').get(0).innerHTML = description;
					
					template.find('.description').find('img:first').click(function(){
					
						nokia.util.vibra();
						
						widget.openURL(link);
						
					});
					
					template.find('.buy').attr('href', openLinkFunction);
					
					var bestSellerContainer = jQuery('<li class="bestseller"></li>').html(template);
					
					bestSellerItensContainer.append(bestSellerContainer);
					
				});
				
				bestSellerItensContainer.find('a[href^=http]').each(function(){
					$(this).click(function(){
						var href = $(this).attr('href');
						
						$(this).attr('href', 'javascript:void(0);')
						
						widget.openURL(href);
						
						return false;
					});
					
				});
				
				nokia.util.hideLoading('#loadingDetailsBestSeller');
				bestSellerItensContainer.show();
				
				instance.feedCache[urlRss] = {feedData:bestSellerItensContainer.html(), date: new Date()};				
			});
		}
		else {
			nokia.util.hideLoading('#loadingDetailsBestSeller');
			var feed = instance.feedCache[urlRss]; 	
			bestSellerItensContainer.html(feed.feedData);
	        bestSellerItensContainer.show();
		}
		
		//back must be there no matter what
		var backFunction = function() {
			instance.goBack(bestSellerListContainer);
			nokia.util.setRightSoftkeyLabel("",null);
		}
				
		instance.backHome.onSelect = backFunction;
		nokia.util.setRightSoftkeyLabel(localizedMenu['Back'], backFunction);
    },
    
    buildRatingStars: function(stars, max) {
    	var isHalf = !(/[^0-9.]/).test(stars) && (/\.\d/).test(stars);
    	var starsContainer = jQuery('<span></span>');
    	
    	var halfStarSrc = 'plugin/img/half-star.png';
    	var fullStarSrc = 'plugin/img/star.png';
    	var emptyStarSrc = 'plugin/img/empty-star.png';
    	
    	for (var i = 1; i < max + 1; i++) {
    		
    		var starImg = jQuery('<img />');
    		starImg.attr('src', isHalf && Math.ceil(stars) == i ? halfStarSrc : fullStarSrc);
    		
    		if ( !(Math.ceil(stars) == i) && i > stars )
    			starImg.attr('src', emptyStarSrc);
    		
    		starsContainer.append(starImg);
    		
    	}
    	
    	return starsContainer;
    	
    },
    
    scrollToCategory: function(category, callback){
        var instance = this;
        
        jQuery('body').animate({
            scrollTop: jQuery('#category_' + category).offset().top - 10
        }, function(){
            if (callback) 
                callback.apply(instance, []);
        });
    },
    
    sortObjectList: function(b, a) {
	    var x = parseInt(a.results);
	    var y = parseInt(b.results);
	
	    return ((x < y) ? -1 : ((x > y) ? 1 : 0));
	},
    
    getUrlSearchFromType: function(type, keywords, data){
        var factory = {
            blended: this.BASE_AMAZON_URL + this.BLENDED_URL,
            singleCategory: this.BASE_AMAZON_URL + this.SINGLE_CATEGORY_URL,
            product: this.BASE_AMAZON_URL + this.RECOVERY_PRODUCT_URL,
        }, url = factory[type]
        
        jQuery.extend(data, {
            key: keywords
        });
		
        jQuery.each(data, function(key, value){
            if (url) {
                var find = '{' + key + '}';
                url = url.replace(find, value);
            }
        });
        
        return url;
    },
    
    goBack: function(currentView) {
    	var cView = jQuery('.view:visible').get(0);
    	var hView = jQuery('#homeView').get(0);
    	var bView = jQuery('#bestSellerListContainer').get(0);
    	var sView = jQuery('#resultListView').get(0);
    	var dView = jQuery('#resultsListContainer').get(0);
    	
    	hideAllViews();
    	
    	var searchInput = jQuery('#mainSearch');
    	
        jQuery('#topSellers').show();
		
    	if (cView == sView) {
    		jQuery(hView).show();
    	} else if(cView == dView) {
			jQuery(hView).show();
		} else if (cView == dView) {
    		jQuery(sView).show();
    	} else if (cView == bView) {
    		jQuery(hView).show();
    	} else {
    		jQuery(hView).show();
    	}
    	
    	var nowVisible = jQuery('.view:visible').get(0);
    	
    	if (nowVisible != sView && nowVisible != dView) {
    		searchInput.val(localizedSearch[3]);
	        searchInput.addClass('unfocused');
	        searchInput.addClass('empty');
    	}
    	
    },
	
	getSearchItems: function(url, callback){
	    /** getting feed data */
    	$.ajax({
        	type: "GET",
	        url: url,
    	    dataType: "json",
        	success: function(data){
	            callback(data);
    	    },
	    	error: function (req, status, error) {
	  			// typically only one of textStatus or errorThrown 
			  // will have info
			  this; // the options for this ajax request
			  var errorData = {requestStatus:req.status, jqueryStatus:status, jqueryError:error};
			  callback(errorData);
			},
			timeout: 30000
    	});
	},
	
	getRSSFeed: function(urlFeed, callback){
	    /** feed container */
    	var feed = [];
		var instance = this;

	    /** getting feed data */
	    $.ajax({
    	   	type: "GET",
	        url: urlFeed,
    	   	dataType: "xml",
	       	success: function(d){
    	       	/** parsin data */
	            $(d).find('item').each(function(){
    	   	        /** current item */
            	    var $item = $(this);
           	    	/** item title */
	               	var title = $item.find('title').text();
		               /** URL to track if user wants to */
    	            var link = $item.find('link').text();
        	        /** item description */
           		    var description = $item.find('description').text();
               	
	               	/** publication date */
	                var pubDate = $item.find('pubDate').text();
               
    	   	        /** pushing itens */
            	    feed.push({
           	    	    title: title,
               	    	link: link,
                   		description: description,
                   		pubDate: pubDate
	               	});
    	       	});
            	callback(feed);
        	},
		   	error: function (XMLHttpRequest, textStatus, errorThrown) {
  				// typically only one of textStatus or errorThrown 
		  		// will have info
				this; // the options for this ajax request
				callback(null);
			},
			timeout: 45000
    	});
		
	},

	/**
	 * Replaces an image with a placeholder or a default image.
	 * 
	 * @param {Object} pExistingImageID
	 * @param {Object} pImageURL
	 */

	getImage: function(pExistingImageID, pImageURL){
	    var img = document.createElement('img');
    	img.onload = function (evt) {
			if (this.width > 1) {
				var existingImage = document.getElementById(pExistingImageID);
				
				if (existingImage) {
					existingImage.src = this.src;
					existingImage.width = this.width;
					existingImage.height = this.height;
				}
			}
			else {
				var image = document.getElementById(pExistingImageID);
				
				if(image)
					image.src = "plugin/img/" + currentCountry + "_noimage.jpg";
			}
	    }
    	img.src = pImageURL;
	    return false;
	},

	/**
	 * add class "active" for an element and remove after 0.2s
 	* @param {Object} element
 	*/
	activateElement: function(element) {
		element.addClass("active");
		setTimeout(function () {
			element.removeClass("active");
		}, 200);
	},
	
	buildItemsListTemplate: function(instance, item) {
		var asin = item.asin;
		var listPrice = item.listPrice || "";
		var author = item.author ||  "";
		var artist = item.artist ||  "";				
		var actors = item.actors || [];
    	var title = item.title;
        var image = item.imageSmall;
        var averagerating = item.rating;
		var availability = item.availability;
		var ourPrice = item.ourPrice || "";
    	var ratingImgs = "";

		if (averagerating)
			ratingImgs = instance.buildRatingStars( averagerating*1, 5 ).html();
				
		if(artist.indexOf(",")>=0) {
			artist = artist.split(",")[1] + " " + artist.split(",")[0];
		}
            	        	
		var url = instance.DESCRIPTION_LINK.replace('{asin}', asin);	
		url += "&tag=" + localizedBaseUrl['tag'] + "&linkCode=plm";
			
		var itemsListTemplate = [];
		
		itemsListTemplate.push('<div id="'+asin+'"><div class="boxBody"><div class="itemData">');
		itemsListTemplate.push('<h3><a href="#" class="itemTitle defaultHanchor" ');
		//itemsListTemplate.push('<h3><a href="#" class="itemOurPrice" style="color:black" ');		
		itemsListTemplate.push('onclick="nokia.util.vibra();widget.openURL(\''+url+'\');">'+item.resultNumber + ". " + nokia.util.wbr(decodeURIComponent(escape(title)))+'</a></h3>');
		itemsListTemplate.push('<p class="description"><img id="' + asin + '" onclick="nokia.util.vibra();widget.openURL(\''+url+'\');" src="plugin/img/static_loader.gif" class="productImage" />');
		
		if(author != "")
			itemsListTemplate.push('<span class="lang" langval="listprice">'+ decodeURIComponent(escape(author))+ '</span><br/>');
		
		if(artist != "")
			itemsListTemplate.push('<span class="lang" langval="listprice">'+ decodeURIComponent(escape(artist))+ '</span><br/>');
		
		if(actors.length > 0)
			itemsListTemplate.push('<span class="lang" langval="listprice">'+ decodeURIComponent(escape(actors.join(", ")))+ '</span><br/>');
		
		if(listPrice != "")
			itemsListTemplate.push('<span class="itemOurPrice" langval="listprice">'+localizedLanguage['listprice']+'</span>: <span class="itemOurPrice">'+decodeURIComponent(escape(listPrice))+'</span><br />');

		if(ourPrice != "")
			itemsListTemplate.push('<span class="itemOurPrice">'+localizedLanguage['ourprice']+'</span>: <span class="red">'+decodeURIComponent(escape(ourPrice))+'</span><br />');
	
		itemsListTemplate.push('<span class="lang">'+ decodeURIComponent(escape(availability))+'</span><br /></p>');
		
		if(ratingImgs != "")
			itemsListTemplate.push('<span class="stars-wrapper">'+ratingImgs+'</span>');
		
		itemsListTemplate.push('<a onclick="nokia.util.vibra();widget.openURL(\''+url+'\');" href="javascript:void(0);" class="buyBtn buy" langval="learnmoreebuy">');
		itemsListTemplate.push(localizedLanguage['learnmoreebuy']+'</a></div></div><hr class="separator" /></div>');

		return itemsListTemplate.join("");								
	}
	,
	
	feedCache: {},
    
    BASE_BEST_SELLERS: localizedBaseUrl['index'],
    
    //BASE_AMAZON_URL: localizedBaseUrl['amazon'],
    
    //BLENDED_URL: "&Operation=ItemSearch&Style=http://nwfu.tecnologia.ws/widgets/amazon/amazonBlendedSearch.xsl&ContentType=text/javascript&SearchIndex=Blended&ResponseGroup=SalesRank&Keywords={keywords}&CallBack=?",
	
	VERSION: "v 1.0.1 - 17/04/2009",
	
	BASE_AMAZON_URL: "http://eu-pp-aw.amazon.com/gp/aw/s/?k={key}&m={store}&json=1&p={page}&si=10",
	
	BLENDED_URL: "",
    
    DESCRIPTION_LINK: localizedBaseUrl['amazonUrl'] + "/gp/aw/d.html?a={asin}&at=" + localizedBaseUrl['tag'],
    
    MENU_BACK: 1,
    
    MENU_HELP: 2,
		
	MENU_ABOUT: 3,
	
	MENU_AM: 4,
		
	MENU_CE: 5,
	
	MENU_CF: 6,
		
	MENU_EN: 7,
	
	MENU_FR: 8,
		
	MENU_GE: 9,
	
	PAGE_SIZE: 10,
	
	MENU_HOME: 11,
    //Response Group =- SalesRank,Small,Offers  - xsl 
    SINGLE_CATEGORY_URL: "", //&Operation=ItemSearch&Style=http://nwfu.tecnologia.ws/widgets/amazon/amazonCategorySearch.xsl&ContentType=text/javascript&ItemPage={itemPage}&SearchIndex={searchIndex}&ResponseGroup=SalesRank,Small,Offers,Images,Reviews,ItemAttributes&Condition=All&Keywords={keywords}&CallBack=?",
    
    RECOVERY_PRODUCT_URL: "&Operation=ItemLookup&Style=http://nwfu.tecnologia.ws/widgets/amazon/amazonSingleAsin.xsl&ContentType=text/javascript&IdType=ASIN&ItemId={itemId}&ResponseGroup=Medium,ItemAttributes,OfferFull&CallBack=?"
});
